# qthing

## Prerequisites
### On NixOS
Run `nix-shell` to load the toolchain

### On other distributions
Install the [ESP32 Toolchain](https://esp-idf.readthedocs.io/) and add it to your PATH

## Get started
* Create or open a device project (see [qthing-subraum](https://git.services.c3pb.de/c3pb/qthing-subraum) for an example)
* Init/update submodules: `git submodule update --init --recursive`
* Run `./bin/set-environment <path_to_environment_file.h>` to set a target environment. This creates a symlink to your target environment file.
* Run `./bin/set_device <path_to_device_directory>` to set a target device. This also creates a symlink.
* Run `./bin/make flash` (or `./make flash monitor`) to build and flash your device

## esp-idf notes
This project includes the esp-idf as a submodule. Use the included script (`./bin/make`) to invoke the toolchain or set your `IDF_PATH` to the projects `esp-idf` directory to avoid version conflicts.

## Disclaimer
The API is not stable yet
